package com.netiq.websocket;

import java.nio.ByteBuffer;

import com.netiq.websocket.exceptions.InvalidFrameException;


public class FramedataImpl1 implements FrameBuilder {
	private static byte[] emptyarray = {};
	private boolean fin;
	private Opcode optcode;
	private ByteBuffer unmaskedpayload;
	private boolean transferemasked;
	
	public FramedataImpl1() {
	   // empty
	}
	public FramedataImpl1( Opcode op ) {
		this.optcode = op;
		unmaskedpayload = ByteBuffer.wrap ( emptyarray );
	}

	public boolean isFin( ) {
		return fin;
	}

	public Opcode getOpcode( ) {
		return optcode;
	}
	
	public boolean getTransfereMasked( ) {
		return transferemasked;
	}

	public byte[] getPayloadData( ) {
		return unmaskedpayload.array ();
	}
	

	public void setFin( boolean fin ) {
		this.fin = fin;
	}
	

	public void setOptcode( Opcode optcode ) {
		this.optcode = optcode;
	}
	
	public void setPayload( byte[] payload ) {
		unmaskedpayload=ByteBuffer.wrap ( payload );
	}
	

	public void setTransferemasked( boolean transferemasked ) {
		this.transferemasked = transferemasked;
	}


	public void append( Framedata nextframe ) throws InvalidFrameException {
		if( unmaskedpayload == null ){
			unmaskedpayload = ByteBuffer.wrap ( nextframe.getPayloadData () );
		}
		else{
			ByteBuffer tmp = ByteBuffer.allocate ( nextframe.getPayloadData ().length + unmaskedpayload.capacity () );
			tmp.put ( unmaskedpayload.array () );
			tmp.put ( nextframe.getPayloadData () );
		}
	}
	
	@Override
	public String toString( ) {
		return "Framedata{ optcode:" + getOpcode() + ", fin:" + isFin() + ", masked:" + getTransfereMasked() +", payloadlength:"+unmaskedpayload.limit()+", payload:" + WebSocket.utf8Bytes(new String ( unmaskedpayload.array () )) + "}" ;
	}

}
