package com.netiq.websocket;

import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedHashMap;

public class HandshakedataImpl1 implements HandshakeBuilder {
	
	private String httpstatusmessage;
	private String resourcedescriptor;
	private byte[] content;
	private LinkedHashMap<String,String> map;
	
	public HandshakedataImpl1() {
		map = new LinkedHashMap<String,String>();
	}

	public HandshakedataImpl1( Handshakedata h ) {
		httpstatusmessage = h.getHttpStatusMessage();
		resourcedescriptor = h.getResourceDescriptor();
		content = h.getContent();
		map = new LinkedHashMap<String,String>( );
		Iterator<String> it = h.iterateHttpFields();
		while ( it.hasNext() ) {
			String key = it.next();
			map.put( key , h.getFieldValue( key ) );
		}
	}

	public String getResourceDescriptor( ) {
		return resourcedescriptor == null ? "" : resourcedescriptor ; //$NON-NLS-1$
	}

	public Iterator<String> iterateHttpFields( ) {
		return Collections.unmodifiableSet( map.keySet () ).iterator ();//Safety first
	}

	public String getFieldValue( String name ) {
		String s = map.get ( name );
		if( s == null ){
			return ""; //$NON-NLS-1$
		}
		return s;
	}

	public byte[] getContent( ) {
		return content;
	}
	
	public void setContent( byte[] content ) {
		this.content = content;
	}
	
	public void setResourceDescriptor( String resourcedescriptor ) {
		this.resourcedescriptor = resourcedescriptor;
	}
	
	public void put( String name, String value ){
		map.put ( name , value );
	}

	public boolean hasFieldValue( String name ) {
		return map.containsKey( name );
	}

	public String getHttpStatusMessage( ) {
		return httpstatusmessage;
	}

	public void setHttpStatusMessage( String message ) {
		this.httpstatusmessage=message;
		
	}

}
