package com.netiq.websocket;

import java.io.IOException;


public class WebSocketAdapter implements WebSocketListener {

	public HandshakeBuilder onHandshakeRecievedAsServer( WebSocket conn , Draft draft , Handshakedata request ) throws IOException {
		return new HandshakedataImpl1();
	}

	public boolean onHandshakeRecievedAsClient( WebSocket conn , Handshakedata request , Handshakedata response ) throws IOException {
		return true;
	}

	public void onMessage( WebSocket conn , String message ) {
	   // to be overriden by subclasses
	}

	public void onOpen( WebSocket conn ) {
      // to be overriden by subclasses
	}

	public void onClose( WebSocket conn ) {
      // to be overriden by subclasses
	}

	public void onError( Throwable ex ) {
		if(WebSocket.DEBUG)
			ex.printStackTrace();
	}

	public void onMessage( WebSocket conn , byte[] blob ) {
      // to be overriden by subclasses
	}

	public void onPong( ) {
      // to be overriden by subclasses
	}

	/**
	* Gets the XML string that should be returned if a client requests a Flash
	* security policy.
	*
	* The default implementation allows access from all remote domains, but
	* only on the port that this WebSocketServer is listening on.
	*
	* This is specifically implemented for gitime's WebSocket client for Flash:
	*     http://github.com/gimite/web-socket-js
	*
	* @return An XML String that comforms to Flash's security policy. You MUST
	*         not include the null char at the end, it is appended automatically.
	*/
	
	
	public String getFlashPolicy( WebSocket conn ) {
		return "<cross-domain-policy><allow-access-from domain=\"*\" to-ports=\"" //$NON-NLS-1$
        + conn.getPort() + "\" /></cross-domain-policy>\0"; //$NON-NLS-1$
	}	

}
